﻿Imports guinet
Public Class Form1

    ' interface to GuiXT
    Public myguixt As New guixt

    ' embed into SAP GUI window
    Public Sub embed(ByVal w As Object)

        ' Add column selector (context menu)
        Dim cs As DataGridViewColumnSelector = New DataGridViewColumnSelector()
        cs.DataGridView = DataGridView1
        cs.MaxHeight = 500
        cs.Width = 110

        ' Set row colors
        DataGridView1.AlternatingRowsDefaultCellStyle.BackColor = Color.AliceBlue

        guixt.EmbedForm(Me, w)
    End Sub

    ' Add data to the dataGridView from a GuiXT table variable
    Public Function AddData(tableName As String) As String

        Dim r As String = ""

        Try

            DataGridView1.Rows.Clear()
            DataGridView1.Columns.Clear()

            ' Number of rows and columns
            Dim cols As Integer = myguixt.GetVariable(tableName & ".colcount")
            Dim rows As Integer = myguixt.GetVariable(tableName & ".rowcount")

            ' Create columns
            For i As Integer = 1 To cols

                Dim colName As String = myguixt.GetVariable(tableName & ".colname." & i.ToString)
                Dim colHeader As String = myguixt.GetVariable(tableName & ".colname." & i.ToString)
                DataGridView1.Columns.Add(colName, colHeader)
            Next

            ' Add rows 
            For i As Integer = 1 To rows

                DataGridView1.Rows.Add()

                For j As Integer = 1 To cols

                    ' Get colname
                    Dim colName As String = DataGridView1.Columns(j - 1).Name

                    ' Get value from guixt table variable
                    Dim val As String = myguixt.GetVariable(tableName & "." & colName & "." & i.ToString)

                    ' Set value in dataGridView
                    DataGridView1.Rows(i - 1).Cells(j - 1).Value = val

                Next
            Next

        Catch ex As Exception

            r = ex.Message

        End Try

        Return r


    End Function

    ' Set dimensions of the dataGridView
    Public Sub SetSize(width As Integer, height As Integer)

        DataGridView1.Height = height
        DataGridView1.Width = width

    End Sub

    ' Set header texts for the columns
    Public Sub SetHeaders(headers As String)

        Dim i As Integer = 0
        For Each s As String In headers.Split("|")

            If (i < DataGridView1.Columns.Count) Then
                DataGridView1.Columns(i).HeaderText = s
            End If

            i += 1
        Next

    End Sub

    ' Add a column that can show images
    Public Sub AddImageCol(path As String, fileColumn As Integer)

        Dim iconColumn As New DataGridViewImageColumn()
        iconColumn.ImageLayout = DataGridViewImageCellLayout.Zoom

        iconColumn.Name = "Picture"
        iconColumn.HeaderText = "Picture"

        DataGridView1.Columns.Insert(DataGridView1.ColumnCount, iconColumn)

        For i As Integer = 0 To DataGridView1.Rows.Count - 1

            Dim fileName As String = (path & DataGridView1.Rows(i).Cells(fileColumn).Value & ".png")

            If System.IO.File.Exists(fileName) Then
                DataGridView1.Rows(i).Cells(DataGridView1.ColumnCount - 1).Value = Image.FromFile(fileName)
            End If

        Next


    End Sub

    ' Set row height of the datagridview 
    Public Sub SetRowHeight(height As Integer)

        DataGridView1.RowTemplate.Height = height

    End Sub



End Class
